#MatFile_gui.py
#based on MatFile.py by Lourdes Mercado
#
# 04 Dec 2001  markdc  Added gui 
# contact:  http://poserutils.tripod.com

#1. set default_mat_file to a usefull default location. The directory must exist.

default_mat_file = "C:\Program Files\Metacreations\Poser 4\Runtime\Libraries\Pose\MAT\matposefile.pz2"



#2 Make sure the figure and Body are selected
#3. enter the new mat file name in the gui. (the directory must exist)
#4. Click save mat




from Tkinter import *


#------------------------------------------------------------
# Determine the operating system
#------------------------------------------------------------
if(os.name == "mac"):  
	macver = 1
elif(os.name == "dos" or os.name == "nt"):  
	macver = 0
else:
	raise "unrecognized operating system\n"


#-------------------------------------------------------------------
# Get filename with quick Tkinter script..
#-------------------------------------------------------------------



textMessage = 	("Create a mat Pose")

if(macver):
	initpath = ':Runtime:Python:poserScripts:matposefile.pz2'
else:
	initpath = default_mat_file


class App:
	def __init__(self, master, textMessage):
		self.yes = 0
		self.master = master
		self.frame = Frame(master)
		self.frame.pack()
		self.message = Label(self.frame, text=textMessage, anchor=N, justify=LEFT)
		self.message.pack()
		self.entry = Entry(self.frame)
		self.entry.insert(END, initpath)
		self.entry.pack(expand=1, fill=BOTH)
		self.buttonyes = Button(self.frame, text="Save Mat", command=self.handleyes)
		self.buttonyes.pack(side=LEFT, expand=1, anchor = S, fill=BOTH)
		self.buttoncancel = Button(self.frame, text="Cancel", command=self.quit)
		self.buttoncancel.pack(side=LEFT, expand=1, anchor = S, fill=BOTH)

	def handleyes(self):
		self.master.quit()
		self.yes = 1
		self.path = self.entry.get()

	def quit(self):
		self.master.quit()

root = Tk()
app = App(root, textMessage)
root.mainloop()

if (not app.yes):
	raise "Script cancelled"

initpath = app.path

scene = poser.Scene()

#md - do this to get a thumbnail. We will write over it shortly
scene.SaveLibraryPose(initpath)

setfile = open(initpath, 'w')

actor = scene.CurrentActor()

figure = actor.ItsFigure()

materials = figure.Materials()

tmpstring = '{\n\n'
setfile.write(tmpstring)

tmpstring = 'version\n\t{\n'
setfile.write(tmpstring)

tmpstring = '\tnumber 4.01\n\t}\n\n'
setfile.write(tmpstring)

tmpstring = 'figure\n\t{\n\t'
setfile.write(tmpstring)

i = 0
for material in materials:

        tmpstring = 'material ' + material.Name() + '\n\t\t{\n\t'
        setfile.write(tmpstring)

        tmpstring = '\tKdColor %g %g %g 1\n\t\t' % (material.DiffuseColor()[0], material.DiffuseColor()[1], material.DiffuseColor()[2])
        setfile.write(tmpstring)

        tmpstring = 'KaColor %g %g %g 1\n\t\t' % (material.AmbientColor()[0], material.AmbientColor()[1], material.AmbientColor()[2])
        setfile.write(tmpstring)

        tmpstring = 'KsColor %g %g %g 1\n\t\t' % (material.SpecularColor()[0], material.SpecularColor()[1], material.SpecularColor()[2])
        setfile.write(tmpstring)

        tmpstring = 'TextureColor %g %g %g 1\n\t\t' % (material.TextureColor()[0], material.TextureColor()[1], material.TextureColor()[2])
        setfile.write(tmpstring)

        tmpstring = 'NsExponent %g \n\t\t' % (material.Ns())
        setfile.write(tmpstring)

        tmpstring = 'tMin %g \n\t\t' % (material.TransparencyMin())
        setfile.write(tmpstring)

        tmpstring = 'tMax %g \n\t\t' % (material.TransparencyMax())
        setfile.write(tmpstring)

        tmpstring = 'tExpo %g \n\t\t' % (material.TransparencyExpo())
        setfile.write(tmpstring)

        tmpstring = 'bumpStrength %g \n\t\t' % (material.BumpStrength())
        setfile.write(tmpstring)

        if materials[i].TextureMapFileName():
           textureName = materials[i].TextureMapFileName()
        else:
           textureName = 'NO_MAP'

        tmpstring = 'textureMap '
        setfile.write(tmpstring)

        setfile.write(textureName)

        if textureName != 'NO_MAP':
           tmpstring = '\n\t\t\t\t0 0\n\t\t'
        else:
           tmpstring = '\n\t\t'
        setfile.write(tmpstring)

        if materials[i].BumpMapFileName():
           bumpmapName = materials[i].BumpMapFileName()
        else:
           bumpmapName = 'NO_MAP'

        tmpstring = 'bumpMap '
        setfile.write(tmpstring)

        setfile.write(bumpmapName)

        if bumpmapName != 'NO_MAP':
           tmpstring = '\n\t\t\t\t0 0\n\t\t'
        else:
           tmpstring = '\n\t\t'
        setfile.write(tmpstring)

        if materials[i].TransparencyMapFileName():
           transparencymapName = materials[i].TransparencyMapFileName()
        else:
           transparencymapName = 'NO_MAP'

        tmpstring = 'transparencyMap '
        setfile.write(tmpstring)

        setfile.write(transparencymapName)

        if transparencymapName != 'NO_MAP':
           tmpstring = '\n\t\t\t\t0 0\n\t\t'
        else:
           tmpstring = '\n\t\t'
        setfile.write(tmpstring)

        if materials[i].ReflectionMapFileName():
           reflectionmapName = materials[i].ReflectionMapFileName()
        else:
           reflectionmapName = 'NO_MAP'

        tmpstring = 'reflectionMap '
        setfile.write(tmpstring)

        setfile.write(reflectionmapName)

        if reflectionmapName != 'NO_MAP':
           tmpstring = '\n\t\t\t\t0 0\n\t\t'
        else:
           tmpstring = '\n\t\t'
        setfile.write(tmpstring)

        tmpstring = 'ReflectionColor %g %g %g 1\n\t\t' % (material.ReflectionColor()[0], material.ReflectionColor()[1], material.ReflectionColor()[2])
        setfile.write(tmpstring)

        tmpstring = 'reflectionStrength %g \n\t\t}\n\t' % (material.ReflectionStrength())
        setfile.write(tmpstring)

        i = i + 1
tmpstring = '}\n}\n'
setfile.write(tmpstring)

setfile.close()


print initpath, 'was successfully created.\n'